/// <reference types="react" resolution-mode="require"/>
import { CodeEditorView } from '@difizen/libro-code-editor';
import type { IEditor, IRange } from '@difizen/libro-code-editor';
import type { CellCollapsible, CellViewOptions } from '@difizen/libro-core';
import { CellService, LibroEditorCellView } from '@difizen/libro-core';
import { MarkdownParser } from '@difizen/libro-markdown';
import { ViewManager } from '@difizen/mana-app';
import type { MarkdownCellModel } from './markdown-cell-model.js';
import './index.less';
export declare const MarkdownCell: import("react").ForwardRefExoticComponent<import("react").RefAttributes<HTMLDivElement>>;
export declare class MarkdownCellView extends LibroEditorCellView implements CellCollapsible {
    get wrapperCls(): "" | "markdown-cell-preview";
    view: import("react").ForwardRefExoticComponent<import("react").RefAttributes<HTMLDivElement>>;
    viewManager: ViewManager;
    editorView?: CodeEditorView;
    editor: IEditor | undefined;
    headingCollapsed: boolean;
    collapsibleChildNumber: number;
    get cellmodel(): MarkdownCellModel;
    markdownParser: MarkdownParser;
    constructor(options: CellViewOptions, cellService: CellService, viewManager: ViewManager, markdownParser: MarkdownParser);
    onViewMount(): void;
    createEditor(): Promise<CodeEditorView>;
    shouldEnterEditorMode(_e: React.FocusEvent<HTMLElement>): boolean;
    focus(toEdit: boolean): void;
    blur(): void;
    redo(): void;
    undo(): void;
    getSelections: () => IRange[];
    getSelectionsOffsetAt: (selection: IRange) => {
        start: number;
        end: number;
    };
}
//# sourceMappingURL=markdown-cell-view.d.ts.map