import { useInject } from '@difizen/mana-app';
import { ViewInstance } from '@difizen/mana-app';
import React, { useEffect, useRef, useCallback } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
export var MarkdownPreview = function MarkdownPreview() {
  var mktRef = useRef(null);
  var instance = useInject(ViewInstance);
  var enterEdit = useCallback(function (e) {
    if (instance.parent.model.readOnly) {
      return;
    }
    e.preventDefault();
    instance.focus(true);
  }, [instance]);
  useEffect(function () {
    if (mktRef.current) {
      mktRef.current.innerHTML = instance.markdownParser.render(instance.model.value, {
        cellId: instance.model.id
      });
    }
  }, [instance, instance.model.value]);
  return /*#__PURE__*/_jsx("div", {
    className: "libro-markdown-warpper-container",
    onDoubleClick: enterEdit,
    children: /*#__PURE__*/_jsx("div", {
      className: "libro-markdown-preview",
      ref: mktRef
    })
  });
};